/** Yes, purely a holder.
	* The idea is to use the class hierarchy mechanism to establish different
	* debug levels.
	* Debug lines now say:
	*		final static Debug DEBUG = new Internal();
	*		if (DEBUG instanceof Internal) {}	//NB: to include sublevels 
	*		if (DEBUG.class == Internal) {}	//NB: to include just this level
	*
	* it was formerly:
	*		final static boolean DEBUG = true;
	*		if (DEBUG) {}
	*
	* I'd like to use the same variable name as before (ie DEBUG), but it will
	* require change-over from boolean to an Object type.
	*
	* I'd also like to have the levels as being inner-classes of Debug, as well
	* as being subclasses.  This enables the relationship to be self-documenting.
	* 	EG: if (DEBUG instanceof Debug.InternalSer.Default)
	* in fact, we could use the innerclass hierarchy *instead* of the subclass
	* hierachy - but then we would lose the ability to include all subclasses.
	*
	* I like this idea - but it does seem a little too sophisticated for what
	* I really need, which is just a small handful of different debug types.
	*/

package JSX;
class Debug {
}
