package JSX;
//package ObjOutDev;
//import JSX.*;	//use this, not package, if trully a "wrapper"
import java.io.*;	//Stream
import java.util.*;	//Vector eg

public class ObjOut extends ObjectOutputStream {
	final boolean DEBUG = false;
	//final boolean DEBUG = true;

	private PrintWriter out;
	public ObjOut(PrintWriter out) throws IOException {
		super();
		this.out = out;
		XMLSerialize.setArg(new Object[] {this});
	}
	public ObjOut(OutputStreamWriter out) throws IOException {
		this(new PrintWriter(out, true));
	}
	public ObjOut(OutputStream out) throws IOException {
		this(new OutputStreamWriter(out));
	}
	//protected ObjOut() throws IOException, SecurityException {
	public ObjOut() throws IOException, SecurityException {
		this(System.out);		//NB: of class "OutputStream"
	}

	public void reset() {
		XMLSerialize.reset();
	}
	protected void writeObjectOverride(Object obj) throws IOException {
		//XMLSerialize.serialize(obj);
		if (DEBUG) System.err.println("writeObject: " +obj+ ", " +out);
		XMLSerialize.serialize(obj, out);	//fine; wrapper APIs must dup a little
	}
		//NB: *must* override, or OOS's version is called
	public void defaultWriteObject() throws IOException {
		if (DEBUG) System.err.println("defaultWriteObject() - need to pass in");
		XMLSerialize.defaultWriteObject();	//just "return" a flag
	}
	public void writeInt(int data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeFloat(float data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeBoolean(boolean data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeByte(int data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeBytes(String data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeChar(int data) throws IOException {	//"int" matches OOS sig
		XMLSerialize.writePrim(data+"");
	}
	public void writeChars(String data) throws IOException {
		XMLSerialize.writePrim(data+"");	//redundant; for consistancy
	}
	public void writeDouble(double data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	//Float - see above
	//Int - see above
		//writeLong() is thanks Andy Thomas (who found Date didn't work).
		//He's the first successful JSX Challenger. Wed, 10 Jan 2001 22:33:57 +0000
		//James Skinnell found it, too (through java.sql.Timestamp not working).
		//He's the second successful JSX Challenger. Thu Jan 11 08:06:28 2001
	public void writeLong(long data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}
	public void writeShort(int data) throws IOException {	//"int" matches OOS
		XMLSerialize.writePrim(data+"");
	}
		/**
		 	* writeUTF(str)
			* ------------
			* NB: Caller may expect repeated writes of the same String object to *not*
			* be the same object - ie to be written out as primitives.
			* writePrim() does this already (I think), since it doesn't know the
			* type of the originating data...
			**/
	public void writeUTF(String data) throws IOException {
		XMLSerialize.writePrim(data+"");
	}

	public static void main(String[] args) throws Exception {
		ObjOut out = new ObjOut();
                Vector v=new Vector();
                Object o=DebugProxy.newInstance(v);
		out.writeObject(o);
//		new ObjOut(new FileWriter(new File("egout.xml"))).writeObject(t);
	//NB: this is inefficient, because we do the same thing twice, but it's
	//just an example.
	}
}
