package momoko.drivers;

import momoko.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.Constructor;

/**
 *  holds external device drivers
 */
public class DriverManager
{
  static public boolean debug=false;
  Hashtable drivers=new Hashtable();

/**
 *  loads device drivers specified in config file
 */
  public DriverManager(String configfile)
  {
    Properties props=new Properties();
    Class c;
    Constructor con;
    Enumeration iterator;
    String s1, s2;

    try {props.load(new FileInputStream(configfile));}
    catch(Exception e)
    {
      if(debug) System.err.println(e.toString());
      return;
    }

    iterator=props.propertyNames();
    while(iterator.hasMoreElements())
    {
      s1=(String)iterator.nextElement();
      try
      {
        s2="momoko.rmi."+props.getProperty(s1);
        c=Class.forName(s2);
        con=c.getConstructor(null);
      }
      catch(Exception e) { continue; }
      drivers.put(s1, con);
    }
  }

/**
 *  creates a new instance of the driver for the given name
 */
  public Object make(String name) throws DriverNotFoundException
  {
    Constructor con;
    Object o;

    con=(Constructor)drivers.get(name);
    if(con==null)
      throw new DriverNotFoundException(name);
    try {o=con.newInstance(null);}
    catch(Exception e)
    { throw new DriverNotFoundException(name); }

    return o;
  }
}
