package momoko.extra;

import momoko.*;
import momoko.user.*;
import java.rmi.RemoteException;
import java.util.*;

public class GenericRoom extends MObject implements Room
{
  static public boolean debug=false;

  public GenericRoom()
  {
    this("");
  }

  public GenericRoom(String name)
  {
    super(name);
  }

  public void say(IMObject player, String args)
  {
    if(debug) System.out.println("say: "+player+" "+args);
    try
    {
      IUser user=(IUser)player;
      if(debug) System.out.println("Invoking user say");
      user.tell("You say, \""+args+"\"");
    }
    catch(ClassCastException e) {if(debug) System.out.println("Sayer is not a user!");}

    announce(player, player.name()+" says, \""+args+"\"");
  }

  public void emote(IMObject player, String args)
  {
    if(debug) System.out.println("emote: "+player+" "+args);
    try
    {
      IUser user=(IUser)player;
      if(debug) System.out.println("Invoking user emote");
      user.tell(user.name()+" "+args);
    }
    catch(ClassCastException e) {if(debug) System.out.println("Emoter is not a user!");}

    announce(player, player.name()+" "+args);
  }

  public void announce(IMObject player, String args)
  {
    Iterator iterator=subdir.keySet().iterator();
    while(iterator.hasNext())
    {
      String name=(String)iterator.next();
      MObject mo=(MObject)subdir.get(name);
      IUser user=null;
      try
      {
        user=(IUser)mo;
        if(user==player) continue;
        user.tell(args);
      }
      catch(ClassCastException e) {}
    }
  }

}
