package momoko.extra;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import momoko.protoclass.*;

/**
 *  a multi-user aware object
 */
public class Irc extends MObject
{
  static public boolean debug=false;

/**
 *  create a new object without a name
 */
public Irc()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public Irc(String newname)
{
  super(newname);
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  return super.create(parent, path, name);
}

private IrcServer regenerate(String name)
{
  if(debug) System.out.println("registering server "+name);
  IrcServer server=null;
  try
  {
    server=(IrcServer)subdir.get(name);

    if(server==null)
    {
      server=new IrcServer(name);
      Database.main.move(server, this);
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
  return server;
}

public IMObject resolve(String path) throws BadPathException
{
if(debug) System.out.println("irc resolve");
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  IrcServer server=regenerate(prefix);
  if(server==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return server;
  }
  else
    return server.resolve(suffix);
}

}
