package momoko.extra;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import org.thalassocracy.irc.*;
import momoko.protoclass.*;

/**
 *  a multi-user aware object
 */
public class IrcServer extends MObject
{
/*
  private IrcClient client;
*/
  private Map clients;

/**
 *  create a new object without a name
 */
public IrcServer()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public IrcServer(String newname)
{
  super(newname);
/*
  try { client = new IrcClient(newname, 6667, "momoko", "momoko", "Momoko"); }
  catch(Exception e) {e.printStackTrace();}
*/
  clients=new Hashtable();
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  return super.create(parent, path, name);
}

private Room regenerate(String name)
{
  Room channel=null;
  try
  {
    channel=(Room)subdir.get(name);

    if(channel==null)
    {
      channel=new GenericIrcRoom(getName(), clients, name);
      channel=(Room)new Describing().makeDescription(channel);
      channel=(Room)new Navigating().makeNavigation(channel);
      Database.main.move(channel, this);
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
  return channel;
}

public IMObject resolve(String path) throws BadPathException
{
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  Room room=regenerate(prefix);
  if(room==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return room;
  }
  else
    return room.resolve(suffix);
}

}
