package momoko.forum;

import momoko.*;
import momoko.proxy.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.rmi.Remote;

public class ContentsAnnotator implements InvocationHandler, Remote
{
    static public boolean debug=false;
    protected String masterPath=null;
    transient private IMObject obj=null;
    Map cache=new OrderedMap();

    public static IMObject newInstance(IMObject o)
    {
        return (IMObject)java.lang.reflect.Proxy.newProxyInstance(
            o.getClass().getClassLoader(), o.getClass().getInterfaces(),
            new ContentsAnnotator(o));
    }

    public ContentsAnnotator(IMObject o)
    {
      obj=o;
      masterPath=obj.getAbsolutePath();
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            if(obj==null)
              obj=Database.main.root.resolve(masterPath);
            if(debug) System.out.println("before link method "+obj+" "+m.getName());
            if(m.getName().equals("resolve"))
            {
              if(cache.isEmpty()) ((IMObject)proxy).contents();
              if(debug) System.out.println("obj: "+obj+" arg: "+args[0]);
              if(debug) System.out.println(obj.contents());
              Object oo=obj.resolve((String)args[0]);
              System.out.println("oo: "+oo);
              IMObject o=(IMObject)oo;
              Annotated a=(Annotated)cache.get(o.getAbsolutePath());
              if(a==null)
              {
                System.out.println("object "+o+" not cached");
                System.out.println(cache);
                a=(Annotated)ViralAnnotationProxy.newInstance(o);
                a.setAnnotation("N");
                cache.put(o.getAbsolutePath(), a);
              }
              return a;
            }
            if(m.getName().equals("contents"))
            {
              Map map=obj.contents();
              Iterator iterator=map.values().iterator();
              while(iterator.hasNext())
              {
                IMObject o=(IMObject)iterator.next();
                if(cache.get(o.getAbsolutePath())==null)
                {
                  Annotated a=(Annotated)ViralAnnotationProxy.newInstance(o);
                  a.setAnnotation("N");
                  cache.put(o.getAbsolutePath(), a);
                }
              }
              return cache;
            }
            if(m.getName().equals("toString")) 
              return "ContentsAnnotator: "+obj.toString();

            result = m.invoke(obj, args);
        } 
        catch (InvocationTargetException e)
        {
            e.printStackTrace();
            throw e.getTargetException();
        } catch (Exception e)
        {
            e.printStackTrace();
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
            if(debug) System.out.println("after method " + m.getName());
        }
        if(debug) System.out.println("returning "+result);
        return result;
    }
}
