package momoko.forum;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import momoko.protoclass.*;

/**
 *  a multi-user aware object
 */
public class GenericContentsAnnotating extends MObject implements ContentsAnnotating
{
  static public boolean debug=false;
  transient IMObject master=null;
  String masterPath=null;

/**
 *  create a new object without a name
 */
public GenericContentsAnnotating()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public GenericContentsAnnotating(String newname)
{
  super(newname);
}

public void setPath(String s)
{
  masterPath=s;
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  return super.create(parent, path, name);
}

public IMObject resolve(String path) throws BadPathException
{
if(debug) System.out.println("GenericContentsAnnotating resolve");
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  IMObject o=null;

  o=(IMObject)subdir.get(prefix);

  if(o==null)
  {
    if(debug) System.out.println("master: "+master+" masterPath: "+masterPath);
    if(master==null && masterPath==null) throw new BadPathException(path);
    if(master==null) master=Database.main.root.resolve(masterPath);
    if(master==null) throw new BadPathException(path);
    o=master.resolve(prefix);
    o=ContentsAnnotator.newInstance(o);
    subdir.put(prefix, o);
  }

  if(debug) System.out.println("o: "+o);
  if(debug) System.out.println("suffix: "+suffix);

  if(suffix.equals(""))
  {
    return o;
  }
  else
    return o.resolve(suffix);
}

}
