package momoko.forum;

import momoko.stream.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import javax.mail.*;
import javax.mail.Session;

/**
 *  a multi-user aware object
 */
public class GenericMailFolder extends MObject implements IMObject, MailFolder
{
  static public boolean debug=false;
  String folderName;
  transient Store store;
  transient Folder folder;

/**
 *  create a new object with the given name
 */
public GenericMailFolder(String newname, Store newStore)
{
  super(newname);
  if(debug) System.out.println("getting store "+newname);
  folderName=newname;
  store=newStore;
  try
  {
    folder=store.getFolder(folderName);
    if(debug) System.out.println(folder.getFullName());
    if(debug) System.out.println(folder.exists());
  }
  catch(Exception e) {e.printStackTrace();}
}

  public IFolder getFolder() throws MessagingException
  {
    if(store==null)
    {
      Session session=Session.getDefaultInstance(System.getProperties(), null);
      store=session.getStore(location().getName());
      System.out.println("store: "+store);
    }
    if(folder==null)
      folder=store.getFolder(folderName);
    return (IFolder)MailFolderProxy.newInstance(folder);
  }

  public void showself(StreamHandler handler)
  {
    super.showself(handler);
    try
    {
      if(folder==null) folder=store.getFolder(folderName);
      handler.println(folder.getMessageCount()+" messages");
    }
    catch(Exception e) {}
  }
}
