package momoko.forum;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import momoko.protoclass.*;

/**
 *  a multi-user aware object
 */
public class Mail extends MObject
{

/**
 *  create a new object without a name
 */
public Mail()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public Mail(String newname)
{
  super(newname);
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  return super.create(parent, path, name);
}

private MailServer regenerate(String name)
{
  System.out.println("registering server "+name);
  MailServer server=null;
  try
  {
    server=(MailServer)subdir.get(name);

    if(server==null)
    {
      server=new MailServer(name);
      Database.main.move(server, this);
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
  return server;
}

public IMObject resolve(String path) throws BadPathException
{
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  MailServer server=regenerate(prefix);
  if(server==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return server;
  }
  else
    return server.resolve(suffix);
}

}
