package momoko.forum;

import java.lang.reflect.*;
import javax.mail.*;

public class MessageProxy implements java.lang.reflect.InvocationHandler {

    private Object obj;

    public static Object newInstance(Object obj) {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            obj.getClass().getInterfaces(),
            new MessageProxy(obj));
    }

    private MessageProxy(Object obj) {
        this.obj = obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            if(m.getName().equals("getFrom")) result=getFrom(m, args);
            else result = m.invoke(obj, args);
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
        }
        return result;
    }

  public String getFrom(Method m, Object[] objects) throws Exception
  {
    Address[] addr=(Address[])m.invoke(obj, objects);
    if(addr.length==0) return "Unknown";
    return addr[0].toString();
  }
}
