package momoko.proxy;

import momoko.*;
import momoko.proxy.*;
import java.rmi.RemoteException;
import java.util.*;
import java.lang.reflect.*;
import java.io.IOException;

  public class AnnotationProxy extends DelegationProxy
  {
    public AnnotationProxy(IMObject object, Annotated annotation, Class[] interfaces) throws BadPathException
    {
      super(interfaces, makeObjects(object, annotation, interfaces));
      System.out.println("new annotation proxy!");
    }

    public AnnotationProxy(IMObject object, Class[] interfaces) throws BadPathException
    {
      super(interfaces, makeObjects(object, interfaces));
      System.out.println("new annotation proxy!");
    }

    static private Object[] makeObjects(IMObject object, Class[] interfaces) throws BadPathException
    {
      return makeObjects(object, new Annotation(""), interfaces);
    }

    static private Object[] makeObjects(IMObject object, Annotated annotation, Class[] interfaces) throws BadPathException
    {
      System.out.println("Making Annotation Proxy: "+object.getAbsolutePath());
      Object[] carr=new Object[interfaces.length];
      int x;
      for(x=0;x<interfaces.length-1;x++)
      {
//        carr[x]=SoftProxy.newInstance(object.getName(), object.getAbsolutePath());
        carr[x]=object;
        if(debug) System.out.println(x+": "+carr[x]);
        if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      }
      carr[x]=annotation;
      if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      return carr;
    }

    public Object invoke(Object proxy, Method m, Object[] args) throws Throwable
    {
      System.out.println("annotation proxy invocation");
      Object o=super.invoke(proxy, m, args);
      if(m.getName().equals("toString"))
        return "AnnotationProxy - "+((String)o);
      return o;
    }

    static public Object newInstance(IMObject obj, Annotated annotation)
    {
      Class[] i, i2;
      if(debug) System.out.println("Making annotation for "+obj);
      i=obj.getClass().getInterfaces();
      i2=new Class[i.length+1];
      int x;
      for(x=0; x<i.length; x++)
      {
        i2[x]=i[x];
        if(debug) System.out.println("Has interface "+i[x]);
      }
      i2[x]=Annotated.class;
      if(debug) System.out.println("Annotating.makeAnnotation("+obj+")");
      try
      {
      InvocationHandler o=new AnnotationProxy(obj, annotation, i2);
      if(debug) System.out.println("new annotation proxy: "+o);
      return java.lang.reflect.Proxy.newProxyInstance(
        obj.getClass().getClassLoader(), i2, o);
      }
      catch(Exception e)
      { e.printStackTrace(); return null; }
    }
  }
