package momoko.proxy;

import momoko.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.rmi.Remote;

public class SoftProxy implements InvocationHandler, Remote
{
    static public boolean debug=false;
    String name;
    public String path;
    transient private Object obj=null;

    public static IMObject newInstance(SoftReference ref) throws BadPathException
    {
      return newInstance(ref.name, ref.path);
    }

    public static IMObject newInstance(String n, String s) throws BadPathException
    {
        Object obj=Database.main.root.resolve(s);
        if(debug) System.out.println("obj: "+obj);
        return (IMObject)java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            getInterfaces(obj.getClass().getInterfaces()),
            new SoftProxy(n, s));
    }

    public SoftReference getReference()
    {
      return new SoftReference(name, path);
    }

    static private Class[] getInterfaces(Class[] old)
    {
      Vector v=new Vector();
      boolean found=false;
      boolean found2=false;
      for(int i=0;i<old.length;i++)
      {
        v.addElement(old[i]);
        if(old[i].equals(Serializable.class)) { found=true; }
        if(old[i].equals(SerializableProxy.class)) { found2=true; }
      }
      if(!found)
        v.addElement(Serializable.class);
      if(!found2)
        v.addElement(SerializableProxy.class);
      Object[] oarr=v.toArray();
      Class[] carr=new Class[oarr.length];
      for(int j=0;j<oarr.length;j++)
        carr[j]=(Class)oarr[j];
      return carr;
    }

    private SoftProxy(String n, String s)
    {
        name=n;
        path=s;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            if(debug) System.out.println("path: "+path);
            if(debug) System.out.println("before link method "+obj+" "+m.getName());
            if(m.getName().equals("equals"))
            {
              if(debug) System.out.println(args[0]+"?="+this.toString());
              if(!Proxy.isProxyClass(args[0].getClass()))
                return Boolean.FALSE;
              InvocationHandler ih=Proxy.getInvocationHandler(args[0]);
              if(!(ih instanceof SoftProxy))
                return Boolean.FALSE;
              String s=((SoftProxy)ih).path;
              return new Boolean(s.equals(path));
            }
            if(m.getName().equals("toString")) return "SoftProxy: "+path+" ("+obj+")";
            if(m.getName().equals("name")) return name;
            if(m.getName().equals("getName")) return name;
            if(m.getName().equals("hashCode")) return new Integer(path.hashCode());
            if(m.getName().equals("location")) return (IMObject)Database.main.contains.subject(this);
            if(m.getName().equals("setlocation")) {Database.main.contains.relateforced((IMObject)args[0], (IMObject)this); return null;}
            if(m.getName().equals("delete"))
            {
              Database.main.delete((IMObject)proxy);
              return Void.TYPE;
            }

            if(m.getName().equals("writeObject"))
            {
              ObjectOutputStream out=(ObjectOutputStream)args[0];
              writeObject(out);
              return null;
            }
            if(m.getName().equals("readObject"))
            {
              ObjectInputStream in=(ObjectInputStream)args[0];
              readObject(in);
              return null;
            }

            if(obj==null) {if(debug) System.out.println("refetching object");    
                   obj=Database.main.root.resolve(path); }
            result = m.invoke(obj, args);
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
           if(debug) System.out.println("after method " + m.getName());
        }
        if(debug) System.out.println("returning "+result);
        return result;
    }

  private void readObject(ObjectInputStream in)
  {
try
{
    SoftReference ref=(SoftReference)in.readObject();
    name=ref.name; path=ref.path; obj=Database.main.root.resolve(path);
}
catch(Exception e) {e.printStackTrace();}
  }

  private void writeObject(ObjectOutputStream out)
  {
try{

    out.writeObject(new SoftReference(name, path));
}
catch(Exception e) {e.printStackTrace();}
  }
}
