package momoko.proxy;

import momoko.*;
import momoko.proxy.*;
import java.rmi.RemoteException;
import java.util.*;
import java.lang.reflect.*;
import java.io.IOException;

public class ViralAnnotationProxy extends DelegationProxy
{
    static boolean debug=false;
    transient protected Hashtable cache=null;

    public ViralAnnotationProxy(IMObject object, Class[] interfaces) throws BadPathException
    {
      super(interfaces, makeObjects(object, interfaces));
      if(debug) System.out.println("new viral annotation proxy!");
    }

    static public Object newInstance(IMObject obj)
    { 
      Class[] i, i2;
      if(debug) System.out.println("Making viral annotation for "+obj);
      i=obj.getClass().getInterfaces();
      i2=new Class[i.length+1];
      int x;
      for(x=0; x<i.length; x++)
      {
        i2[x]=i[x];
        if(debug) System.out.println("Has interface "+i[x]);
      }
      i2[x]=Annotated.class;
      try
      {
      InvocationHandler o=new ViralAnnotationProxy(obj, i2);
      if(debug) System.out.println("new viral annotation proxy: "+o);
      return java.lang.reflect.Proxy.newProxyInstance(
        obj.getClass().getClassLoader(), i2, o);
      }
      catch(Exception e)
      { e.printStackTrace(); return null; }
    }

    static private Object[] makeObjects(IMObject object, Class[] interfaces) throws BadPathException
    {
      if(debug) System.out.println("Making ViralAnnotation Proxy: "+object.getAbsolutePath());
      Object[] carr=new Object[interfaces.length];
      int x;
      for(x=0;x<interfaces.length-1;x++)
      {
        carr[x]=SoftProxy.newInstance(object.getName(), object.getAbsolutePath());
        if(debug) System.out.println(x+": "+carr[x]);
        if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      }
      carr[x]=new Annotation("");
      if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      return carr;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        if(debug) System.out.println("viral invocation");
        Object o=super.invoke(proxy, m, args);
        if(m.getName().equals("resolve"))
        {
          if(debug) System.out.println("a viral resolve has been invoked");
          if(cache==null) cache=new Hashtable();
          Object p=cache.get(o);
          if(p!=null) return p;
          p=newInstance((IMObject)o);
          cache.put(o, p);
          return p;
        }
        if(m.getName().equals("toString"))
          return "Viral - "+((String)o);
        return o;
    }
}
