package momoko.rmi;

import java.util.Hashtable;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import momoko.*;
import momoko.rpc.*;

public class RMIServer implements RemoteObjectServer
{
  Registry registry;
  Hashtable exported;
  int port;

  public void initialize(int p) throws Exception
  {
    port=p;
    if(registry!=null) return;
    registry=LocateRegistry.createRegistry(port);
    exported=new Hashtable();
  }

  public int getPort() {return port;}

  public Object justexport(Remote obj) throws RemoteException
  {
      if(exported.containsKey(obj))
        return (IMObject)obj;
      RemoteStub rs=UnicastRemoteObject.exportObject(obj);
      exported.put(obj, this); // nonsense value because you can't put null
//System.out.println("returning "+rs+" from export");
      return rs;
  }

  public void export(Remote obj, String dest) throws RemoteException
  {
    try
    {
      Object rs=justexport(obj);
      bind(dest, obj);
    }
    catch(Exception e) { e.printStackTrace(); throw new RemoteException(); }
  }

  public void bind(String dest, Remote obj) throws Exception
  {
    registry.bind(dest, obj);
  }

  public IMObject lookup(String dest) throws Exception
  {
    return (IMObject)registry.lookup(dest);
  }

  public void shutdown()
  {
  }
}
