package momoko.server;

import momoko.*;
import momoko.stream.*;
import momoko.client.*;
import momoko.user.*;
import java.util.*;

public class LoginInterpreter extends Interpreter implements IClientSideInterface
{
  IUser avatar;
  String name;
  String pass;

  public LoginInterpreter() { super(); }

  public void initialize()
  {
    handler.format("Welcome to Momoko. Type 'help' for help.");
  }

  public boolean interpret(Object command)
  {
    try {return interpretforreal((String[])command);}
    catch(ClassCastException e) {return false;}
  }

  private boolean interpretforreal(String[] command)
  {
    if(command[0].equals("name"))
      name=command[1];
    else if(command[0].equals("pass")&&(name!=null))
    {
      pass=command[1];
      System.out.println("Registering "+name+" "+pass);
      avatar=Registry.main.register(this, name, pass);
      System.out.println("Avatar is "+avatar);
      if(avatar==null)
      {
        handler.format("Wrong name or password.");
        return false;
      }
      else
      {
//        CommandInterpreter ci=new CommandInterpreter();
        handler.format("Logged in...");
        CommandInterpreter ci=new momoko.extra.PsuedoMOOInterpreter();
        try
        {
          ((momoko.forum.User)avatar).setConnectedStatus(true);
          ((momoko.forum.User)avatar).setLastActionTime(new Date());
        }
        catch(Exception e) {}
	ci.setavatar(avatar);
	handler.setinterpreter(ci);
      }
    }
    else if(command[0].equals("new"))
    {
      Registry.main.newuser(command[1],command[2]);
      handler.format("New user created");
      return true;
    }
    else if(command[0].equals("connect"))
    {
      interpretforreal(new String[] {"name", command[1]});
      interpretforreal(new String[] {"pass", command[2]});
    }
    else if(command[0].equals("help"))
    {
      handler.format("name [name] -- enter your username");
      handler.format("pass [pass] -- enter your password");
      handler.format("new [name] [pass] -- create a new user");
      handler.format("connect [name] [pass] -- enter your username and password");
    }
    return true;
  }

  public void print(String str)
  {
    handler.format(str);
  }
}
