package momoko.server;

import java.io.*;
import java.util.*;
import momoko.*;

/**
 *  holds modules
 */
public class ModuleLoader
{
  Hashtable modules=new Hashtable();

/**
 *  loads modules specified in config file
 */
  public ModuleLoader(String configfile)
  {
    Properties props=new Properties();
    Properties props2;
    Class c;
    Enumeration iterator;
    String s1, s2;
    Module mod;

    try {props.load(new FileInputStream(configfile));}
    catch(Exception e)
    {
      System.out.println(e.toString());
      return;
    }

    iterator=props.propertyNames();
    while(iterator.hasMoreElements())
    {
      s1=(String)iterator.nextElement();
      try
      {
        s2=props.getProperty(s1);
        props2=new Properties();
        props2.load(new FileInputStream("config/"+s1+".config"));
        String loc=props2.getProperty("location");
        IMObject location=Database.main.resolve(Database.main.root, loc);
        String name=props2.getProperty("name");
        mod=(Module)Database.main.addobj(s2, location, name);
        mod.initialize(props2);
        modules.put(s1, mod);
      }
      catch(Exception e)
      {
        System.out.println("Error loading module "+s1);
        e.printStackTrace();
        continue; 
      }
    }
  }

  public void initialize()
  {
  }

  public void display()
  {
    System.out.println("Modules loaded:");
    Enumeration iterator=modules.keys();
    while(iterator.hasMoreElements())
      System.out.println(iterator.nextElement());
    System.out.println(".");
  }

  public void shutdown()
  {
    Enumeration iterator=modules.elements();
    while(iterator.hasMoreElements())
      ((Module)iterator.nextElement()).shutdown();
  }
}
