package momoko.server;

import momoko.*;
import momoko.user.*;
import momoko.rpc.*;
import momoko.stream.*;
import java.io.PrintStream;

public class MudServer
{
 public static boolean running=true;
 private static ServiceManager manager;
 private static ModuleLoader loader;

 public static void main( String[] args )
 {
  if(Database.main==null) Database.main=new Database();
  Database db=Database.main;
  RemoteObjectServer remote=db.remoteint;
  MObject world;
  Object o;
  
  int rmiport;
  if(args.length!=2)
  {
    System.out.println("server <hostname> <port>");
    System.exit(1);
  }

  db.setHostname(args[0]);
  rmiport=Integer.parseInt(args[1]);

//  SubjectExclusiveRelationship.debug=true;

  try
  {
    remote.initialize(rmiport);
    db.initialize();
//    System.out.println("Inited");
    world=(MObject)db.regenerate("MObject",db.root,"world");
    try{IMObject god=db.resolve(db.root, "God");
    db.move(god,world);}
    catch(BadPathException e) {}
//    SQLDB sqldb=(SQLDB)Database.main.addobj("SQLDB",world,"db");
//    sqldb.initialize();
    db.tree();
// System.out.println(Database.main.addobj("OrderedView",world,"view"));
    Database.main.broker.bind(new Registry(), "registry");
    Database.main.broker.bind(db.root.resolve("class"), "repository");
    remote.export(Database.main.broker, "StrawBroker");
//    loader=new ModuleLoader("config/modules.config");
//    loader.initialize();
//    loader.display();
    manager=new ServiceManager("config/services.config");
    manager.initialize();
    manager.display();
//    System.out.println(db.addobj("MudObject","ejb","mobj"));
    System.setOut(new PrintStream(new RedirectedStream()));
  }
  catch( Exception exception )
  {
    System.err.println("MudServer.main(): "+exception);
    exception.printStackTrace();
    MudServer.shutdown();
  }
 }

 static public void shutdown()
 {
   running=false;
   if(Database.main!=null) Database.main.shutdown();
   if(manager!=null) manager.shutdown();
   System.exit(0);
 }
}
