package momoko.server;

import momoko.stream.*;
import momoko.drivers.*;
import java.net.*;
import java.util.*;
import momoko.*;
import java.io.*;

public class ScriptFileService implements Service, Runnable
{
  boolean running=true;
  Thread thread;

  String str;
  Class parserclass;
  Class formatterclass;
  Class interpreterclass;

    Parser parser;
    Formatter formatter;
    Interpreter interpreter;
    StreamHandler handler;
    FileInputStream infile=null;

    public void run()
    {
        try
        {
          parser=(Parser)parserclass.newInstance();
          formatter=(Formatter)formatterclass.newInstance();
          interpreter=(Interpreter)interpreterclass.newInstance();
          handler=new StreamHandler();
	  handler.setparser(parser);
	  handler.setformatter(formatter);
	  handler.setinstream(infile);
	  handler.setoutstream(new FileOutputStream(new File("script.out")));
	  handler.setinterpreter(interpreter);
	  handler.initialize();
          handler.handle();
        }
        catch(Exception e)
        {
            System.out.println("Error starting service on script file");
            e.printStackTrace();
        }
    }

  public void initialize(Properties args) throws
  UnspecifiedArguementException, BadArguementException, IOException,
  DriverNotFoundException
  {
    str=args.getProperty("file");
    if(str==null)
      throw new UnspecifiedArguementException();
    infile=new FileInputStream(str);
    str=args.getProperty("parser");
    if(str==null)
      throw new UnspecifiedArguementException();
    str="momoko.server."+str+"Parser";
    try {parserclass=Class.forName(str);}
    catch(Exception e) {throw new DriverNotFoundException(str);}
    str=args.getProperty("interpreter");
    if(str==null)
      throw new UnspecifiedArguementException();
    str="momoko.server."+str+"Interpreter";
    try {interpreterclass=Class.forName(str);}
    catch(Exception e) {throw new DriverNotFoundException(str);}
    str=args.getProperty("formatter");
    if(str==null)
      throw new UnspecifiedArguementException();
    str="momoko.server."+str+"Formatter";
    try {formatterclass=Class.forName(str);}
    catch(Exception e) {throw new DriverNotFoundException(str);}
  }

  public void service()
  {
    thread=new Thread(this, "script file listener");
    thread.start();
  }

  public void shutdown()
  {
    running=false;
    thread.interrupt();
  }
}
