package momoko.straw;

import momoko.*;
import java.lang.reflect.*;

public class StrawProxy implements java.lang.reflect.InvocationHandler, java.rmi.Remote
{
    static public boolean debug=false;
    private StrawReference obj;
    private StrawBroker broker;

    public static Object newInstance(StrawBroker b, StrawReference obj) 
    {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            obj.getInterfaces(),
            new StrawProxy(b, obj));
    }

    private StrawProxy(StrawBroker broker, StrawReference obj) {
        this.broker = broker;
        this.obj = obj;
//System.out.println("New proxy:");
//System.out.println(this.broker);
//Class[] interfaces=this.obj.getClass().getInterfaces();
//for(int x=0;x<interfaces.length;x++)
//  System.out.println(interfaces[x]);
//System.out.println(".");
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
          if(debug) System.out.println("before method " + m.getName());

//if(m.getName().equals("getClass")) {return obj.getPrimaryClass();}
if(m.getName().equals("equals")) {return proxyEquals(proxy, args[0]);}
//if(m.getName().equals("resolve")) {System.out.println("!!! "+this);}
if(m.getName().equals("toString")) {return "StrawProxy: "+obj.toString();}
            if(m.getName().equals("location"))
            { return (IMObject)Database.main.contains.subject(proxy); }

            result = obj.invoke(broker, m, args);
            if(result instanceof Exception)
            {
              throw (Exception)result;
            }

            if(result instanceof StrawReference)
            {
if(debug)
{
  System.out.println("new proxy for reference");
  Class[] inst=((StrawReference)result).getInterfaces();
  for(int j=0;j<inst.length;j++) System.out.println(inst[j]);
}

              result = newInstance(broker, (StrawReference)result);
            }
            else if(result instanceof StrawArrayReference)
            {
if(debug) System.out.println("result is an array reference");
              result = (Object)importArrayReference((StrawArrayReference)result);
            }
        } 
        catch (InvocationTargetException e)
        {
//System.out.println("exception");
            throw e.getTargetException();
        } catch (Exception e)
        {
//System.out.println("exception");
e.printStackTrace();
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
//            System.out.println("after method " + m.getName());
        }
//        System.out.println("for "+m.getName()+" returning "+result);
        return result;
    }

  protected Boolean proxyEquals(Object proxy, Object other)
  {
    return (proxy == other ? Boolean.TRUE : Boolean.FALSE);
  }

  protected Object[] importArrayReference(StrawArrayReference ref)
  {
    StrawReference[] refs=ref.getRefs();
    Object item=StrawProxy.newInstance(broker, refs[0]);
    Object o=Array.newInstance(item.getClass(), refs.length);
    for(int x=0;x<refs.length;x++)
      Array.set(o, x, StrawProxy.newInstance(broker, refs[x]));
    return (Object[])o;
  }
}
