package momoko.straw;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;
import java.rmi.Remote;
import momoko.*;

public class StrawReference implements Serializable
{
  static public boolean debug=false;
  private Integer ref;
  private InetAddress addr;
  private int port;
  private Class primary;
  private Class[] interfaces;

  public StrawReference(Integer newref, Class newprimary, Class[] newinterfaces)
  {
    ref=newref;
    primary = newprimary;
    interfaces=newinterfaces;
//System.out.println("New reference:");
//System.out.println(ref);
//for(int x=0;x<interfaces.length;x++)
//  System.out.println(interfaces[x]);
//System.out.println(".");
    try { addr=InetAddress.getLocalHost(); }
    catch(Exception e) {e.printStackTrace();}
    port=Database.main.remoteint.getPort();
  }

  public String toString()
  {
    return "StrawReference: "+addr+":"+port+"/"+ref;
  }

  public boolean isLocal() throws UnknownHostException {return InetAddress.getLocalHost().equals(addr) && (port==Database.main.remoteint.getPort());}

  public InetAddress getAddress() {return addr;}

  public int getPort() {return port;}

  public Integer getId() {return ref;}

  public Class getPrimaryClass() {return primary;}

  public Class[] getInterfaces() {return interfaces;}

  public Object invoke(StrawBroker broker, Method m, Object[] objects) throws Exception
  {
    if(debug) System.out.println("Reference invoking "+ref+"."+m.getName()+"()");
    Object o=(Object)objects;
    o=Database.main.broker.checkAndConvert(o);
    return broker.call(ref, m.getName(), o);
  }
}
