package momoko.stream;

import java.io.*;
import momoko.server.*;

public class RedirectedStream extends OutputStream
{
  PrintStream oldOut;

  public RedirectedStream()
  {
    super();
    oldOut=System.out;
  }

  public PrintStream getSystemOut()
  {
    return oldOut;
  }

  public void write(int b)
  {
//    oldOut.println("Redirected write: "+b);
    Thread t=Thread.currentThread();
    if(t==null || !(t instanceof RedirectingThread))
    {
      oldOut.write(b);
      return;
    }
    RedirectingThread ut=(RedirectingThread)t;
    OutputStream os=ut.getOutputStream();
    try { os.write(b); }
    catch(Exception e) {e.printStackTrace();}
  }
}
