package momoko.stream;

import java.io.*;

public class StreamHandler
{
  protected PrintWriter writer=null;
  protected InputStream in=null;
  protected OutputStream out=null;
  protected Parser parser=null;
  protected Interpreter interpreter=null;
  protected Formatter formatter=null;

  public StreamHandler()
  {
  }

  public StreamHandler(Parser p, Interpreter i, Formatter f)
  {
    setparser(p);
    setinterpreter(i);
    setformatter(f);
  }

  public void setparser(Parser p)
  {
    parser=p;
    p.sethandler(this);
  }

  public Parser getParser()
  {
    return parser;
  }

  public void setformatter(Formatter f)
  {
    formatter=f;
    f.sethandler(this);
  }

  public void setinterpreter(Interpreter i)
  {
//    System.out.println("Set interpreter!");
    interpreter=i;
    i.sethandler(this);
    i.initialize();
  }

    public Interpreter getInterpreter()
    {
	return interpreter;
    }

  public void setinstream(InputStream is)
  {
    in=is;
  }

  public InputStream getInputStream() {return in;}
  public OutputStream getOutputStream() {return out;}

  public void setoutstream(OutputStream os)
  {
    out=os;
    writer=new PrintWriter(out);
  }

  public void initialize() {}

  public void handle()
  {
    Object o;

    while(true)
    {
//System.out.println("calling parser parse ("+parser+")");
      o=parser.parse(in);
//System.out.println("returned object "+o);
      if(o==null)
        break;
      boolean b=interpreter.interpret(o);
//      System.out.println("b: "+b);
      if(!b) break;
    }
  }

  public void format(Object o)
  {
    writer.print(formatter.format(o));
    writer.flush();
  }

  public void print(Object o)
  {
    writer.print(o);
    writer.flush();
  }

  public void println(Object o)
  {
    writer.println(o);
    writer.flush();
  }
}
