package momoko.types;

import momoko.*;
import momoko.protoclass.*;
import java.util.*;
import java.lang.reflect.*;

public class Types
{
  public static Class integer;
  public static Class list;
  public static Class string;
  public static Class object;
  public static Class function;
  public static Class socket;
  public static Class dictionary;
  private Hashtable names=new Hashtable();
  private Hashtable user=new Hashtable();
  protected static boolean debug = false;

  public Types()
  {
  try {
  integer = Class.forName("java.lang.Integer");
  list = Class.forName("java.util.Vector");
  string = Class.forName("java.lang.String");
  object = Class.forName("momoko.MObject");
  function = Class.forName("momoko.protoclass.Function");
  socket = Class.forName("java.lang.Integer");
  dictionary = Class.forName("java.util.Hashtable");
  } catch(ClassNotFoundException e)
  {
    if(debug) System.out.println("One of the basic types wasn't found.");
  }
  names.put("Integer",integer);
  names.put("Array",list);
  names.put("String",string);
  names.put("object",object);
  names.put("Function",function);
  names.put("socket",socket);
  names.put("dictionary",dictionary);
  }

  public void add(String name)
  {
    if(debug) System.out.println("Adding new type "+name);
    try{user.put(name, Database.loader.loadClass(name));}
    catch(ClassNotFoundException e) {if(debug) System.out.println("Could not add new type "+name);}
  }

  public Class named(String name)
  {
    Class c=(Class)names.get(name);

    if(c!=null)
      return c;
    else
      return (Class)user.get(name);
  }

  public String classname(String name)
  {
    if(debug) System.out.println("looking for a class named "+name);
    Class c=named(name);
    if(c==null) return "void";
    return c.getName();
  }

  public boolean checktype(String typename, Object obj)
  {
    if(debug) System.out.println("Is "+obj+" a "+typename+"?");
    Class c=named(typename);
    if(obj==null) {if(debug) System.out.println("null is all classes"); return true;}
    if(c==null) {if(debug) System.out.println("no class"); return false;}
    return c.isInstance(obj);
  }

  public Object convert(String newtype, String value)
  {
    if(debug) System.out.println("Attempting conversion to "+newtype);
    if(newtype.equals("String"))
      return value;
    else if(newtype.equals("Array"))
    {
      return new MudArray(value);
    }
    else if(newtype.equals("Integer"))
      return new Integer(value);
    else if(newtype.equals("Function"))
      return new Function("void", new Vector());
    else if(user.get(newtype)!=null)
    {
      if(debug) System.out.println("might be an image");
      try
      {
        Class c=(Class)user.get(newtype);
        Class[] caar=new Class[1];
        caar[0]=Class.forName("java.lang.String");
        Object[] oaar=new Object[1];
        oaar[0]=value;
        Method m=c.getMethod("create", caar);
        MObject o=(MObject)m.invoke(null, oaar);
        o.setparent(Database.main.resolve(Database.main.classroot,newtype));
        return o;
      }
      catch(Exception e) { e.printStackTrace(); return null; }
    }      
    else
      return null;
  }
}
  
