package momoko.user;

import java.rmi.Remote;
import momoko.compiler.Compiler;
import momoko.*;
import momoko.protoclass.*;
import momoko.versioncontrol.*;

/**
 *  Class implementor - can modify classes
 */
public class Developer extends User implements IDeveloper, Remote
{
  public Developer(String name)
  {
    super(name);
  }

/**
 *  create a new class
 */
  public IProtoClass newclass(String parent, String name)
  {
    VersionController vc;
    vc=(VersionController)Database.main.addobj("VersionController",Database.main.classroot,name);
    IProtoClass pc=vc.getCurrent();
    pc.initialize(parent);
    return (IProtoClass)pc;
  }

  public void setlang(IProtoClass pc, String newlang)
  {
    if(pc!=null)
      pc.setlanguage(newlang);
  }

  public IMObject importObj(String parent, String loc, String name)
  {
    return Database.main.importObj(parent, loc, name);
  }

/**
 *  create a new object
 */
  public IMObject newobj(String parent, String loc, String name)
  {
//System.out.println("parent: "+parent);
//System.out.println("location: "+loc);
//System.out.println("name: "+name);
try{
    if(loc==null)
    {
      return (IMObject)Database.main.addobj(parent, location(), name);
    }
    else
      return (IMObject)Database.main.addobj(parent, loc, name);
}catch(Exception e) {e.printStackTrace(); return null;}
  }

  public void delobj(String name)
  {
    Database.main.delobj(name);
  }

  public void move(String spath, String dpath)
  {
    try{
    Database.main.move(Database.main.resolve(location(),spath),Database.main.resolve(location(),dpath));
    } catch(Exception e) { System.out.println(e); }
  }

/**
 *  get an object based on its path
 */
  public IMObject getobj(String name)
  {
    try
    {
      IMObject o=Database.main.root.resolve(name);
      System.out.println("o: "+o);
      return o;
    }
    catch(Exception e)
    {
      e.printStackTrace();
      return null;
    }
  }

  public IProtoClass newversion(String path)
  {
    VersionController vc;

    try{
      vc=(VersionController)Database.main.resolve(Database.main.classroot, path);
      return (IProtoClass)vc.newversion();
    } catch(BadPathException e) {return null;}
  }

/**
 *  compile and load a class
 */
  public void compile(String path, Compiler comp)
  {
    VersionController vc;

    try
    {
      vc=(VersionController)Database.main.resolve(Database.main.classroot, path);
      IProtoClass pc=vc.getCurrent();
      comp.compile(pc);
    }
    catch(Exception e) { 
      e.printStackTrace(); return;}
  }
}
