package momoko.user;

import java.rmi.server.*;
import java.rmi.Remote;
import momoko.*;
import momoko.client.*;

/**
 *  allows clients to connect to the server
 */
public class Registry extends MObject implements Remote, IRegistry
{
  static public boolean debug=false;
  static public Registry main;

  public Registry()
  {
    super("");
    main=this;
  }

public IUser register(ClientSideInterface c, String n, String p)
{
  return register((IClientSideInterface)c, n, p);
}

/**
 *  returns the user's avatar and makes the location of the avatar available for mounting
 */
  public IUser register(IClientSideInterface client, String name, String password)
  {
    IUser avatar;
    IMObject world;

if(debug) System.out.println("Registry.register("+client+", "+name+", "+password+")");
    try
    {
      try { avatar=(IUser)Database.main.root.resolve("/world/db/"+name); }
      catch(BadPathException e)
      { avatar=(IUser)Database.main.root.resolve("/world/"+name); }
      if(avatar==null)
        return null;
      avatar.setclient(client);
      if(debug) System.out.println("avatar is "+avatar);
      world=(IMObject)Database.main.contains.subject(avatar);
      Database.main.broker.bind(world, name+"+"+password);
      return (IUser)avatar;
    }
    catch(Exception e)
    {
      if(debug) System.out.println("A nasty exception of the sort that is "+e.toString());
      e.printStackTrace();
      return null;
    }
  }

  public boolean newuser(String name, String password)
  {
    try
    {
      if(name.equals("God"))
        if(password.equals("God"))
          return true;
      IMObject root=Database.main.root;
      IMObject db=root.resolve("world/db");
      IMObject user=null;
      try { user=db.resolve(name); }
      catch(BadPathException e) {}
      if(user!=null) {if(debug) System.out.println("user exists"); return false;}
      momoko.forum.User u=(momoko.forum.User)db.create("momoko.forum.GenericUser", "", name);
      u.setPassword(password);
      return true;
    }
    catch(Exception e)
    {
      e.printStackTrace();
      return false;
    }
  }
}
