package momoko.user;

import java.rmi.Remote;
import momoko.*;
import momoko.client.*;

/**
 *  Normal user - allows interfacing with local objects
 */
public class User extends MObject implements IUser, Remote
{
  static public boolean debug=false;
  transient IClientSideInterface client=null;
  int position=0;

  public User(String name)
  {
    super(name);
  }

public void tell(String args)
{
  if(debug) System.out.println("User.tell(\""+args+"\")");
  // no paranoia or gagging at the moment
  notify(args);
}

public void notify(String args)
{
  if(debug) System.out.println("User.notify(\""+args+"\")");
  if(debug) System.out.println(client);
  if(client!=null)
    client.print(args);
  else
    if(debug) System.out.println("User has no client.");
}

/**
 *  move avatar forward one space
 */
  public void forward()
  {
    position=position+1;
  }

/**
 *  set the client currently being interface with
 */
  public void setclient(IClientSideInterface newclient)
  {
    client=newclient;
  }

  public IClientSideInterface getClient()
  {
    return client;
  }

  public void whisper(IMObject user, String args)
  {
     notify(user.getName()+" whispers, \""+args+"\"");
  }
}
