package momoko.util;

import java.io.*;
import java.util.*;

public class StringUtils {

    static public void main(String[] args) throws IOException
    {
      BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
      System.out.println(stripSubject(in.readLine()));
    }

    static public Vector split(String path, String delim)
    {
        int i;
        Vector parts=new Vector();

        if (path==null) {
            return parts;
        }

        while(path.length()>0) {
            i = path.indexOf(delim);

            if (i == -1) {
                parts.addElement(path);
                break;
            } else {
                parts.addElement(path.substring(0,i));
                path = path.substring(i+1);
            }
        }

        return parts;

    }

    static public String replace(String s, String olds, String news)
    {
        StringBuffer rb = new StringBuffer("");
        int i, j;

        i = 0;
        while ((j = s.indexOf(olds, i))!=-1) {
            rb.append(s.substring(i,j));
            rb.append(news);
            i = j + olds.length();
        }
        rb.append(s.substring(i));

        return rb.toString();
    }

  static public String join(Vector v, String delim)
  {
    StringBuffer buff=new StringBuffer();
    Enumeration iterator=v.elements();
    while(iterator.hasMoreElements())
    {
      String s=(String)iterator.nextElement();
      buff.append(s);
      if(iterator.hasMoreElements())
        buff.append(delim);
    }
    return buff.toString();
  }

  static public String wrap(String text, int width)
  {
    char[] foo = text.toCharArray();

    int dist = 0;
    for (int i=0; i<foo.length; i++) {
      if (foo[i] == '\n') {
        dist = 0;
      } else if (dist == width) {
        for (int j=0; j>-width; j--) {
          if (foo[i-j] == ' ') {
            foo[i-j] = '\n';
            dist = 0;
            break;
          }
        }
      } else if ((dist > width) && (foo[i] == ' ')) {
        foo[i] = '\n';
        dist = 0;
      } else {
        dist++;
      }
    }

    return new String(foo);
  }

  static public boolean detectReply(String subject)
  {
    subject=subject.toLowerCase();
    if(subject.startsWith("re:"))
      return true;
    if(subject.startsWith("re["))
      return true;
    return false;
  }

  /** A method that strips off Re: and such from a message.
   *  This really should go in MailUtils, but there currently is no
   *  such thing.
   */
  static public String stripSubject(String subject)
  {
    if(subject==null)
    {
//      System.out.println("Steve! You sent me a freakin' null subject! What's the deal?");
      return null;
    }
    String temp=subject.toLowerCase();
    boolean done=false;
    while(!done)
    {
      done=true;
      temp=subject.toLowerCase();
      if(temp.startsWith("re:"))
      {
        done=false;
        subject=subject.substring(3).trim();
        continue;
      }
      if(temp.startsWith("re["))
      {
        done=false;
        subject=subject.substring(3);
        int i=subject.indexOf(']');
        if(i==-1) // Freak out. I don't know how to handle this.
        {
//          System.out.println("You gave me a funky subject to strip: "+subject);
          return subject.trim();
        }
       subject=subject.substring(i+2).trim();
      }
    }
    return subject;
  }
}
