package momoko.versioncontrol;

import java.util.*;
import momoko.*;
import java.lang.reflect.*;
import java.beans.*;

/**
 *  a working representation of a future Java class
 */
public class ObjectInfo extends MObject
{
  private Hashtable properties=new Hashtable();
  String objparent, objname;
  IMObject objloc;

/**
 * create a new class without a name
 */
public ObjectInfo(IMObject obj)
{
  try{
  objloc=obj.location();
  objparent=obj.getparent().name();
  objname=obj.name();
  System.out.println("Infoifying "+objloc+" "+objparent+" "+objname);
  Class c=obj.getClass();
  BeanInfo bi=Introspector.getBeanInfo(c);
  PropertyDescriptor[] pd=bi.getPropertyDescriptors();
  for(int x=0; x<pd.length; x++)
  {
    Method m=pd[x].getReadMethod();
    Object value=m.invoke(obj, null);
    System.out.println("= "+pd[x].getName()+" "+value);
    add(pd[x].getName(), value);
  }
  Database.main.delobj(obj.path());
  } catch(Exception e) {e.printStackTrace();}
}

public void add(String name, Object value)
{
  properties.put(name, value);
}

public void restore()
{
  try{
  IMObject obj=Database.main.addobj(objparent, objloc, objname);
  Class c=obj.getClass();
  BeanInfo bi=Introspector.getBeanInfo(c);
  PropertyDescriptor[] pd=bi.getPropertyDescriptors();
  for(int x=0; x<pd.length; x++)
  {
    Method m=pd[x].getWriteMethod();
    Object[] oarr = new Object[1];
    oarr[0]=properties.get(pd[x].getName());
    m.invoke(obj, oarr);
  }
  } catch(Exception e) {e.printStackTrace();}
}

}
