package momoko.vfs;

import momoko.*;
import java.io.*;
import java.net.*;
import java.util.*;
import HTTPClient.*;
import momoko.util.*;

public class HttpFile extends File
{
    private String path;
    private String name;
    boolean dir=false;
    private Vector subdir;
    private String hostname;

    static public void main(String[] args)
    {
      unitTest();
    }

    static public void unitTest()
    {
    }

    static public void print(String prefix, HttpFile f)
    {
      System.out.println(prefix+f.getName());
      String[] sub=f.list();
      if(sub==null) return;
      for(int x=0;x<sub.length;x++)
        print(prefix+" ", new HttpFile(f, sub[x]));
    }

    public HttpFile(HttpFile parent, String child)
    {
      super(parent, child);
System.out.println("HttpFile(HttpFile, String)");
      path=parent.getAbsolutePath();
      if(!child.equals("") && !child.startsWith("/"))
        path=path+"/"+child;
      name=path;
System.out.println("set path: "+path);
      initialize();
    }

    public HttpFile(String path)
    {
      super(path);
System.out.println("HttpFile("+path+")");
      this.path=path;
      name=path;
      try { hostname=new URL(path).getHost(); }
      catch(Exception e) {e.printStackTrace();}
System.out.println("Before init: "+name);
      initialize();
      System.out.println("Hello my path is "+path);
    }

    public HttpFile(String parent, String child)
    {
      this(new HttpFile(parent), child);
    }

    public InputStream getInputStream()
    {
System.out.println("GETINPUTSTREAM()");
try{
      URL url=new URL(path);
System.out.println("url: "+url);
      URLConnection connection=url.openConnection();
System.out.println("URLConnection: "+connection);
      return connection.getInputStream();
}
catch(Exception e) {e.printStackTrace(); return null;}
    }

    public OutputStream getOutputStream()
    {
      HttpOutputStream stream=new HttpOutputStream();
      HTTPConnection con = new HTTPConnection(hostname, 8080);
      try
      {
        HTTPResponse rsp = con.Put(name, stream);
      }
      catch(Exception e) {e.printStackTrace(); return null;}
      return stream;
    }

    protected void initialize()
    {
try
{
      Vector v=StringUtils.split(path, "/");
      if(v.size()>2)
        name=(String)v.elementAt(v.size()-1);
      URL url=new URL(path);
      name=url.getFile();
      if(name.startsWith("/"))
        name=name.substring(1);
System.out.println("name: "+name);
      URLConnection connection=url.openConnection();
System.out.println("URLConnection: "+connection);
      String type=connection.getContentType();
System.out.println("type: "+type);
      v=StringUtils.split(type, ";");
System.out.println("v: "+v);
      type=(String)v.elementAt(0);
System.out.println("type: "+type);
      if(type.equals("text/directory"))
      {
        System.out.println("File is directory ("+name+")");
        dir=true;
        subdir=new Vector();
        InputStream in=connection.getInputStream();
        BufferedReader br=new BufferedReader(new InputStreamReader(in));
        String s=br.readLine();
        while(s!=null)
        {
          if(!s.equals(""))
            subdir.addElement(s);
          s=br.readLine();
        }
        System.out.println("v: "+subdir);
      }
      else
      {
        System.out.println("File is not a directory");
        dir=false;
      }
}
catch(Exception e) {e.printStackTrace();}
    }

    public  String getName() {return name;}
    public  String getParent() {return null;}
    public  File getParentFile() {return null;}
    public  String getPath() {return path;}
    public boolean isAbsolute() {return false;}
    public  String getAbsolutePath() {return path;}
    public  File getAbsoluteFile() {return this;}

    public  String getCanonicalPath() throws  IOException
    {
System.out.println("getCanonicalPath()");
      return new URL(path).getPath();
    }

    public  File getCanonicalFile() throws  IOException
    {
      return this;
    }

    public  URL toURL() throws  MalformedURLException
    {
      return null;
    }

    public boolean canRead() { return true; }

    public boolean canWrite() { return true; }
    public boolean exists() { return true; }
    public boolean isDirectory() { return dir; }
    public boolean isFile() { return true; }
    public boolean isHidden() { return false; }
    public long lastModified() { return 0; }
    public long length() { return 0; }
    public boolean createNewFile() {return false;}
    public boolean delete() {return false;}
    public void deleteOnExit() {}
    public  String[] list()
    {
      if(subdir==null) return null;
      String[] sarr=new String[subdir.size()];
      for(int x=0;x<sarr.length;x++)
        sarr[x]=(String)subdir.elementAt(x);
      return sarr;    
    }
    public  String[] list( FilenameFilter f) { return null; }
    public  File[] listFiles()
    {
      String[] names=list();
      if(names==null) return null;
      File[] files = new File[names.length];
      for(int x=0;x<files.length;x++)
        files[x]=new HttpFile(this, names[x]);
      return files;
    }
    public  File[] listFiles( FilenameFilter f) {return null;}
    public  File[] listFiles( FileFilter f) {return null;}
    public boolean mkdir() {return false;}
    public boolean mkdirs() { return false;}
    public boolean renameTo( File f) {return false;}
    public boolean setLastModified(long l) {return false;}
    public boolean setReadOnly() {return false;}
/*    public String toString()
    {
      System.out.println("toString()");
      System.out.println("path: "+path);
      System.out.println(super.toString());
      return super.toString();
    }
*/
}
