package momoko.vfs;

import javax.swing.filechooser.*;
import java.io.*;
import momoko.*;

public class HttpFileSystemView extends FileSystemView
{
  protected String hostname;

  public HttpFileSystemView(String newHostname)
  {
    hostname=newHostname;
  }

  public File createFileObject(File dir, String filename)
  {
System.out.println("createFileObject("+dir+", "+filename+")");
    if(filename.equals("/")) filename="";
    HttpFile newFile=new HttpFile((HttpFile)dir, filename);
    return newFile;
  }

  public File createFileObject(String path)
  {
System.out.println("createFileObject("+path+")");
    if(!path.startsWith("http://"))
      return createFileObject(getHomeDirectory(), path);
    HttpFile newFile = null;
    try { newFile = new HttpFile(path); }
    catch(Exception e) {}
    if(isRoot(newFile))
      return newFile;
    else
      return createFileObject(getHomeDirectory(), path);
  }

  public File createNewFolder(File container)
  {
System.out.println("createNewFolder");
    HttpFile newFile=new HttpFile((HttpFile)container, "dir.dir");
    return newFile;
  }

  public File[] getFiles(File dir, boolean useFileHiding)
  {
System.out.println("getFiles("+dir+", "+useFileHiding+")");
System.out.println("dir: "+dir);
System.out.println("Returning "+dir.listFiles());
    return dir.listFiles();
  }

  public File getHomeDirectory()
  {
System.out.println("getHomeDirectory");
    return new HttpFile(hostname);
  }

  public File getParentDirectory(File dir)
  {
System.out.println("getParentDirectory");
    return dir;
  }

  public File[] getRoots()
  {
System.out.println("getRoots()");
    HttpFile[] roots = new HttpFile[1];
    roots[0] = new HttpFile(hostname);
    return roots;
  }

  public boolean isHiddenFile(File f)
  {
System.out.println("isHiddenFile");
    return false;
  }

  public boolean isRoot(File f)
  {
    if(f==null) return false;
System.out.println("isRoot("+f+")");
    return f.getAbsolutePath().equals(hostname);
  }
}
