package momoko.vfs;

import momoko.*;
import java.io.*;
import java.net.*;
import java.util.*;
import JSX.*;

public class ObjectFile extends File implements VirtualFile
{
    static public boolean debug=false;
    private String path;
    private String name;
    boolean dir=false;
    private Vector subdir;
    protected IMObject obj;

    static public void main(String[] args)
    {
      unitTest();
    }

    static public void unitTest()
    {
      ObjectFile f=new ObjectFile("/world");
      print("", f);
    }

    static public void print(String prefix, ObjectFile f)
    {
      if(debug) System.out.println(prefix+f.getName());
      String[] sub=f.list();
      if(sub==null) return;
      for(int x=0;x<sub.length;x++)
        print(prefix+" ", new ObjectFile(f, sub[x]));
    }

    public ObjectFile(IMObject obj)
    {
      this(obj.getName());
      this.obj=obj;
      if(debug) System.out.println("exitting constructor");
    }

    public ObjectFile(ObjectFile parent, String child)
    {
      super(parent, child);
if(debug) System.out.println("ObjectFile(ObjectFile, String)");
      path=parent.getAbsolutePath()+"/"+child;
      int i=path.lastIndexOf('/');
      name=path.substring(i+1);
if(debug) System.out.println("set path: "+path);
      initialize();
    }

    public ObjectFile(String path)
    {
      super(path);
if(debug) System.out.println("ObjectFile("+path+")");
      this.path=path;
      int i=path.lastIndexOf('/');
      name=path.substring(i+1);
if(debug) System.out.println("Before init: "+name);
      initialize();
      if(debug) System.out.println("Hello my path is "+path);
    }

    public ObjectFile(String parent, String child)
    {
      super(parent, child);
if(debug) System.out.println("ObjectFile(String, String)");
      path=parent+"/"+child;
      int i=path.lastIndexOf('/');
      name=path.substring(i+1);
if(debug) System.out.println("set path: "+path);
      initialize();
    }

    public InputStream getInputStream()
    {
try
{
      File f=File.createTempFile("ObjectFile", ".xml");
      if(debug) System.out.println("f: "+f);
      FileOutputStream fos=new FileOutputStream(f);
      if(debug) System.out.println("fos: "+fos);
      ObjOut oo = new ObjOut(fos);
      if(debug) System.out.println("oo: "+oo);
      oo.writeObject(obj);
      fos.close();
      FileInputStream fis=new FileInputStream(f);
      return fis;
}
catch(Exception e)
{
  e.printStackTrace();
  return null;
}
    }

    public OutputStream getOutputStream()
    {
try{
      PipedInputStream pin = new PipedInputStream();
      PipedOutputStream pout = new PipedOutputStream(pin);
      ObjIn oi = new ObjIn(pin);
      return pout;
}
catch(Exception e)
{
  e.printStackTrace();
  return null;
}
    }

    protected void initialize()
    {
    }

    public  String getName() {return name;}
    public  String getParent() {return null;}
    public  File getParentFile() {return null;}
    public  String getPath() {return path;}
    public boolean isAbsolute() {return false;}
    public  String getAbsolutePath() {return path;}
    public  File getAbsoluteFile() {return this;}

    public  String getCanonicalPath() throws  IOException
    {
if(debug) System.out.println("getCanonicalPath()");
if(debug) System.out.println("returning "+path);
      return path;
    }

    public  File getCanonicalFile() throws  IOException
    {
      return this;
    }

    public  URL toURL() throws  MalformedURLException
    {
      return null;
    }

    public boolean canRead() { return true; }
    public boolean canWrite() { return true; }
    public boolean exists() { return true; }
    public boolean isDirectory() { return dir; }
    public boolean isFile() { return true; }
    public boolean isHidden() { return false; }
    public long lastModified() { return 0; }
    public long length() { return 0; }
    public boolean createNewFile() {return false;}
    public boolean delete() {return false;}
    public void deleteOnExit() {}
    public  String[] list()
    {
      if(subdir==null) return null;
      String[] sarr=new String[subdir.size()];
      for(int x=0;x<sarr.length;x++)
        sarr[x]=(String)subdir.elementAt(x);
      return sarr;    
    }
    public  String[] list( FilenameFilter f) { return null; }
    public  File[] listFiles()
    {
      String[] names=list();
      if(names==null) return null;
      File[] files = new File[names.length];
      for(int x=0;x<files.length;x++)
        files[x]=new ObjectFile(this, names[x]);
      return files;
    }
    public  File[] listFiles( FilenameFilter f) {return null;}
    public  File[] listFiles( FileFilter f) {return null;}
    public boolean mkdir() {return false;}
    public boolean mkdirs() { return false;}
    public boolean renameTo( File f) {return false;}
    public boolean setLastModified(long l) {return false;}
    public boolean setReadOnly() {return false;}
/*    public String toString()
    {
      if(debug) System.out.println("toString()");
      if(debug) System.out.println("path: "+path);
      if(debug) System.out.println(super.toString());
      return super.toString();
    }
*/
}
