package momoko.webserver;

import momoko.*;
import momoko.stream.*;
import momoko.server.*;
import java.util.*;
import java.lang.reflect.*;
import java.io.*;

public class HttpResourceLoader extends CommandInterpreter implements FileServer
{
  public static String url="http://"+Database.main.getHostname()+":7070/";
  ClassLoader loader;

  public HttpResourceLoader()
  {
    super();
    h.put("GET", new get());
System.out.println("Http Interpreter linking to class loader");
    Database.main.loader.setServer(this);
  }

  public String getURL()
  {
    return url;
  }

  public void setLoader(ClassLoader l)
  {
    loader=l;
  }

private class get implements Command
{
  public void execute(String[] command, CommandInterpreter interp)
    {
      String url=command[1];
      while(url.startsWith("/"))
        url=url.substring(1);
      if(url.equals(""))
        url=".";
      System.out.println("getting URL "+url);      
      System.out.println(loader);
      PrintWriter pw=new PrintWriter(handler.getOutputStream());
      InputStream in=null;
      in=loader.getResourceAsStream(url);
      System.out.println(in);
      if(in==null)
      {
        handler.format("HTTP/1.1 404 Not Found");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
      }
      else
      {
        handler.format("HTTP/1.1 200 OK");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
        OutputStream out=handler.getOutputStream();
        Conduit c=new Conduit(in, out);
        c.run();
      }
      interp.close();
    }
}

}
